Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.expr.sort
Class DoubleSortComparer

    java.lang.Object
      net.sf.saxon.expr.sort.DoubleSortComparer

All Implemented Interfaces:
  Serializable, AtomicComparer

    public class DoubleSortComparer

extends Object
implements AtomicComparer

An AtomicComparer used for sorting values that are known to be numeric. It also supports a separate method for getting a collation key to test equality of items. This comparator treats NaN values as equal to each other, and less than any other value.

Author:
  Michael H. Kay
See Also:
  Serialized Form

Method Summary
`int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Test whether two values compare equal.
`StringCollator` | `getCollator()` Get the collation used by this AtomicComparer if any
`ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.
`static DoubleSortComparer` | `getInstance()` Get the singular instance of this class
`AtomicComparer` | `provideContext(XPathContext context)` Supply the dynamic context in case this is needed for the comparison

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getInstance

    public static DoubleSortComparer getInstance()

  Get the singular instance of this class

  Returns:
    the singular instance

### getCollator

    public StringCollator getCollator()

  Description copied from interface: `AtomicComparer`
  Get the collation used by this AtomicComparer if any

  Specified by:
    `getCollator` in interface `AtomicComparer`
  Returns:
    the collation used for comparing strings, or null if not applicable

### provideContext

    public AtomicComparer provideContext(XPathContext context)

  Supply the dynamic context in case this is needed for the comparison

  Specified by:
    `provideContext` in interface `AtomicComparer`
  Parameters:
    `context` - the dynamic evaluation context
  Returns:
    either the original AtomicComparer, or a new AtomicComparer in which the context is known. The original AtomicComparer is not modified

### compareAtomicValues

    public int compareAtomicValues(AtomicValue a,
                                   AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type.

  Specified by:
    `compareAtomicValues` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared. It is intended that this should normally be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a 0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### comparesEqual

    public boolean comparesEqual(AtomicValue a,
                                 AtomicValue b)

  Test whether two values compare equal. Note that for this comparer, NaN is considered equal to itself

  Specified by:
    `comparesEqual` in interface `AtomicComparer`
  Parameters:
    `a` - the first object to be compared.
    `b` - the second object to be compared.
  Returns:
    true if the values are equal, false if not

### getComparisonKey

    public ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal as defined by the XPath eq operator, then their comparison keys are equal as defined by the Java equals() method, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

  Specified by:
    `getComparisonKey` in interface `AtomicComparer`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (c) 2004-2011 Saxonica Limited. All rights reserved.